diff --git a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index 51ca70739..c586e7889 100644
--- a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -3,14 +3,12 @@ package net.minecraft.client.gui.popup;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Scissor;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.Arrays;
-import java.util.Collections;
 import java.util.List;
 
 public class MessageBoxComponent
@@ -126,7 +124,7 @@ public class MessageBoxComponent
         // Draw lines
         for (int i = 0; i < lines.size(); i++)
         {
-            minecraft.fontRenderer.drawStringWithShadow(lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels(),0xFFFFFFFF);
+            minecraft.font.drawStringWithShadow(lines.get(i),x + 4,(y + 4) + (i * 12) - getScrollPixels(),0xFFFFFFFF);
         }
 
         Scissor.disable();
diff --git a/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java b/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
index c6772d60c..5dc36b76d 100644
--- a/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
+++ b/src/main/java/net/minecraft/client/gui/popup/PopupBuilder.java
@@ -1,18 +1,18 @@
 package net.minecraft.client.gui.popup;
 
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.collection.Pair;
 
 import java.util.*;
 
-import static net.minecraft.client.gui.popup.GuiPopup.VERTICAL_MARGIN;
-import static net.minecraft.client.gui.popup.GuiPopup.HORIZONTAL_MARGIN;
-import static net.minecraft.client.gui.popup.GuiPopup.COMPONENT_GAP;
+import static net.minecraft.client.gui.popup.PopupScreen.VERTICAL_MARGIN;
+import static net.minecraft.client.gui.popup.PopupScreen.HORIZONTAL_MARGIN;
+import static net.minecraft.client.gui.popup.PopupScreen.COMPONENT_GAP;
 
 public class PopupBuilder
 {
-    private final GuiScreen parent;
+    private final Screen parent;
     private final int width;
     private Integer statusCodeOnEsc = null;
     private Integer statusCodeOnEnter = null;
@@ -22,15 +22,15 @@ public class PopupBuilder
     private final List<PopupCloseListener> onCloseListeners = new ArrayList<>();
     private Pair<Integer,Integer> backgroundColor = null;
 
-    public PopupBuilder(GuiScreen parent, int width)
+    public PopupBuilder(Screen parent, int width)
     {
         this.parent = parent;
         this.width = width;
     }
 
-    public GuiPopup build()
+    public PopupScreen build()
     {
-        GuiPopup popup = new GuiPopup(
+        PopupScreen popup = new PopupScreen(
                 parent,
                 width,
                 getHeight(),
diff --git a/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java b/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
index 82d54047c..01cf5ccc7 100644
--- a/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/PopupComponent.java
@@ -2,7 +2,7 @@ package net.minecraft.client.gui.popup;
 
 public abstract class PopupComponent
 {
-    private GuiPopup parent = null;
+    private PopupScreen parent = null;
     private final int width;
 
     public PopupComponent(int width)
@@ -10,12 +10,12 @@ public abstract class PopupComponent
         this.width = width;
     }
 
-    public void setParent(GuiPopup parent)
+    public void setParent(PopupScreen parent)
     {
         this.parent = parent;
     }
 
-    public GuiPopup getParent()
+    public PopupScreen getParent()
     {
         return parent;
     }
diff --git a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java b/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
similarity index 76%
rename from src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
rename to src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
index 8aa438cd8..f569d36b0 100644
--- a/src/main/java/net/minecraft/client/gui/popup/GuiPopup.java
+++ b/src/main/java/net/minecraft/client/gui/popup/PopupScreen.java
@@ -1,213 +1,213 @@
-package net.minecraft.client.gui.popup;
-
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.util.collection.Pair;
-import org.lwjgl.input.Keyboard;
-import org.lwjgl.opengl.GL11;
-
-import java.util.*;
-
-public final class GuiPopup
-    extends GuiScreen
-{
-    static final int HORIZONTAL_MARGIN = 8;
-    static final int VERTICAL_MARGIN = 8;
-    static final int COMPONENT_GAP = 4;
-
-
-    private final GuiScreen parent;
-    private final int popupWidth;
-    private final int popupHeight;
-
-    private final Integer statusCodeOnEsc;
-    private final Integer statusCodeOnEnter;
-    private final Integer statusCodeOnClickOut;
-    private final List<PopupComponent> components;
-    private final Map<PopupComponent, String> componentKeyMap;
-    private final List<PopupCloseListener> onCloseListeners;
-
-    private final Pair<Integer,Integer> backgroundColor;
-
-    private int statusCode = -1;
-
-    GuiPopup(
-            GuiScreen parent,
-            int width,
-            int height,
-            Integer statusCodeOnEsc,
-            Integer statusCodeOnEnter,
-            Integer statusCodeOnClickOut,
-            List<PopupComponent> components,
-            Map<PopupComponent, String> componentKeyMap,
-            List<PopupCloseListener> onCloseListeners,
-            Pair<Integer,Integer> backgroundColor
-    )
-    {
-        this.parent = parent;
-        this.popupWidth = width;
-        this.popupHeight = height;
-        this.statusCodeOnEsc = statusCodeOnEsc;
-        this.statusCodeOnEnter = statusCodeOnEnter;
-        this.statusCodeOnClickOut = statusCodeOnClickOut;
-        this.components = components;
-        this.componentKeyMap = componentKeyMap;
-        this.onCloseListeners = onCloseListeners;
-        this.backgroundColor = backgroundColor;
-    }
-
-    void close(int statusCode)
-    {
-        this.statusCode = statusCode;
-        this.onClosed();
-        mc.currentScreen = parent;
-    }
-
-    @Override
-    public void tick()
-    {
-        super.tick();
-
-        for (PopupComponent component : components)
-        {
-            component.tick();
-        }
-    }
-
-    @Override
-    public void onClosed()
-    {
-        super.onClosed();
-
-        Map<String, Object> results = new HashMap<>();
-        for (Map.Entry<PopupComponent, String> entry : componentKeyMap.entrySet())
-        {
-            if (entry.getKey() instanceof InteractivePopupComponent<?>)
-            {
-                Object value = ((InteractivePopupComponent<?>) entry.getKey()).getOutput();
-                results.put(entry.getValue(), value);
-            }
-        }
-
-        for (PopupCloseListener listener : onCloseListeners)
-        {
-            listener.onClosed(statusCode, results);
-        }
-    }
-
-    @Override
-    public void init()
-    {
-        if (parent.width != width || parent.height != height)
-        {
-            parent.width = width;
-            parent.height = height;
-            parent.controlList.clear();
-            parent.init();
-        }
-
-        super.init();
-    }
-
-    @Override
-    public void keyTyped(char c, int key, int mouseX, int mouseY)
-    {
-        if (key == Keyboard.KEY_ESCAPE && statusCodeOnEsc != null)
-        {
-            close(statusCodeOnEsc);
-        }
-        if (key == Keyboard.KEY_RETURN && statusCodeOnEnter != null)
-        {
-            close(statusCodeOnEnter);
-        }
-        for (PopupComponent component : components)
-        {
-            component.onKeyDown(key, c);
-        }
-    }
-
-    @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
-    {
-        if (statusCodeOnClickOut != null)
-        {
-            int popupX = width / 2 - popupWidth / 2;
-            int popupY = height / 2 - popupHeight / 2;
-
-            if (mouseX < popupX || mouseX > popupX + popupWidth || mouseY < popupY || mouseY > popupY + popupHeight)
-            {
-                close(statusCodeOnClickOut);
-            }
-        }
-
-        super.mouseClicked(mouseX, mouseY, mouseButton);
-
-        for (PopupComponent component : components)
-        {
-            component.onClick(mouseX, mouseY, mouseButton);
-        }
-    }
-    
-    @Override
-    public void mouseMovedOrButtonReleased(int mouseX, int mouseY, int mouseButton)
-    {
-    	super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
-    	
-    	for(PopupComponent component : components) {
-    		component.mouseMovedOrUp(mouseX, mouseY, mouseButton);
-    	}
-    }
-
-    @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
-    {
-        int popupX = width / 2 - popupWidth / 2;
-        int popupY = height / 2 - popupHeight / 2;
-
-        parent.drawScreen(-1, -1, partialTick);
-
-        drawPopupBackground();
-
-        int accY = popupY + VERTICAL_MARGIN;
-
-        for (PopupComponent component : components)
-        {
-            component.render(popupX + HORIZONTAL_MARGIN, accY, mouseX, mouseY);
-            accY += component.getHeight() + COMPONENT_GAP;
-        }
-
-        super.drawScreen(mouseX, mouseY, partialTick);
-    }
-
-    private void drawPopupBackground()
-    {
-        int popupX = width / 2 - popupWidth / 2;
-        int popupY = height / 2 - popupHeight / 2;
-
-        GL11.glDisable(GL11.GL_LIGHTING);
-        GL11.glDisable(GL11.GL_FOG);
-        Tessellator tessellator = Tessellator.instance;
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-
-        if(backgroundColor == null){
-            int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
-            drawGradientRect(0, 0, width, height, color, color);
-        } else {
-            drawGradientRect(0, 0, width, height, backgroundColor.getLeft(), backgroundColor.getRight());
-        }
-
-
-        drawRectWidthHeight(popupX - 1, popupY - 1, popupWidth + 2, popupHeight + 2, 0xFFA0A0A0);
-
-        GL11.glEnable(GL11.GL_TEXTURE_2D);
-        float f = 32F;
-        tessellator.startDrawingQuads();
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-        tessellator.setColorOpaque_I(0x404040);
-        tessellator.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
-        tessellator.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
-        tessellator.addVertexWithUV(popupX + popupWidth, popupY, 0.0D, (float)popupWidth / f, 0);
-        tessellator.addVertexWithUV(popupX, popupY, 0.0D, 0.0D, 0);
-        tessellator.draw();
-    }
-}
+package net.minecraft.client.gui.popup;
+
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.util.collection.Pair;
+import org.lwjgl.input.Keyboard;
+import org.lwjgl.opengl.GL11;
+
+import java.util.*;
+
+public final class PopupScreen
+    extends Screen
+{
+    static final int HORIZONTAL_MARGIN = 8;
+    static final int VERTICAL_MARGIN = 8;
+    static final int COMPONENT_GAP = 4;
+
+
+    private final Screen parent;
+    private final int popupWidth;
+    private final int popupHeight;
+
+    private final Integer statusCodeOnEsc;
+    private final Integer statusCodeOnEnter;
+    private final Integer statusCodeOnClickOut;
+    private final List<PopupComponent> components;
+    private final Map<PopupComponent, String> componentKeyMap;
+    private final List<PopupCloseListener> onCloseListeners;
+
+    private final Pair<Integer,Integer> backgroundColor;
+
+    private int statusCode = -1;
+
+    PopupScreen(
+            Screen parent,
+            int width,
+            int height,
+            Integer statusCodeOnEsc,
+            Integer statusCodeOnEnter,
+            Integer statusCodeOnClickOut,
+            List<PopupComponent> components,
+            Map<PopupComponent, String> componentKeyMap,
+            List<PopupCloseListener> onCloseListeners,
+            Pair<Integer,Integer> backgroundColor
+    )
+    {
+        this.parent = parent;
+        this.popupWidth = width;
+        this.popupHeight = height;
+        this.statusCodeOnEsc = statusCodeOnEsc;
+        this.statusCodeOnEnter = statusCodeOnEnter;
+        this.statusCodeOnClickOut = statusCodeOnClickOut;
+        this.components = components;
+        this.componentKeyMap = componentKeyMap;
+        this.onCloseListeners = onCloseListeners;
+        this.backgroundColor = backgroundColor;
+    }
+
+    void close(int statusCode)
+    {
+        this.statusCode = statusCode;
+        this.removed();
+        mc.currentScreen = parent;
+    }
+
+    @Override
+    public void tick()
+    {
+        super.tick();
+
+        for (PopupComponent component : components)
+        {
+            component.tick();
+        }
+    }
+
+    @Override
+    public void removed()
+    {
+        super.removed();
+
+        Map<String, Object> results = new HashMap<>();
+        for (Map.Entry<PopupComponent, String> entry : componentKeyMap.entrySet())
+        {
+            if (entry.getKey() instanceof InteractivePopupComponent<?>)
+            {
+                Object value = ((InteractivePopupComponent<?>) entry.getKey()).getOutput();
+                results.put(entry.getValue(), value);
+            }
+        }
+
+        for (PopupCloseListener listener : onCloseListeners)
+        {
+            listener.onClosed(statusCode, results);
+        }
+    }
+
+    @Override
+    public void init()
+    {
+        if (parent.width != width || parent.height != height)
+        {
+            parent.width = width;
+            parent.height = height;
+            parent.buttons.clear();
+            parent.init();
+        }
+
+        super.init();
+    }
+
+    @Override
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
+    {
+        if (eventKey == Keyboard.KEY_ESCAPE && statusCodeOnEsc != null)
+        {
+            close(statusCodeOnEsc);
+        }
+        if (eventKey == Keyboard.KEY_RETURN && statusCodeOnEnter != null)
+        {
+            close(statusCodeOnEnter);
+        }
+        for (PopupComponent component : components)
+        {
+            component.onKeyDown(eventKey, eventCharacter);
+        }
+    }
+
+    @Override
+    public void mouseClicked(int mx, int my, int buttonNum)
+    {
+        if (statusCodeOnClickOut != null)
+        {
+            int popupX = width / 2 - popupWidth / 2;
+            int popupY = height / 2 - popupHeight / 2;
+
+            if (mx < popupX || mx > popupX + popupWidth || my < popupY || my > popupY + popupHeight)
+            {
+                close(statusCodeOnClickOut);
+            }
+        }
+
+        super.mouseClicked(mx, my, buttonNum);
+
+        for (PopupComponent component : components)
+        {
+            component.onClick(mx, my, buttonNum);
+        }
+    }
+    
+    @Override
+    public void mouseReleased(int mx, int my, int buttonNum)
+    {
+    	super.mouseReleased(mx, my, buttonNum);
+    	
+    	for(PopupComponent component : components) {
+    		component.mouseMovedOrUp(mx, my, buttonNum);
+    	}
+    }
+
+    @Override
+    public void render(int xm, int ym, float partialTick)
+    {
+        int popupX = width / 2 - popupWidth / 2;
+        int popupY = height / 2 - popupHeight / 2;
+
+        parent.render(-1, -1, partialTick);
+
+        drawPopupBackground();
+
+        int accY = popupY + VERTICAL_MARGIN;
+
+        for (PopupComponent component : components)
+        {
+            component.render(popupX + HORIZONTAL_MARGIN, accY, xm, ym);
+            accY += component.getHeight() + COMPONENT_GAP;
+        }
+
+        super.render(xm, ym, partialTick);
+    }
+
+    private void drawPopupBackground()
+    {
+        int popupX = width / 2 - popupWidth / 2;
+        int popupY = height / 2 - popupHeight / 2;
+
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_FOG);
+        Tessellator tessellator = Tessellator.instance;
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+
+        if(backgroundColor == null){
+            int color = mc.gameSettings.guiBackgroundColor.value.getARGB();
+            drawGradientRect(0, 0, width, height, color, color);
+        } else {
+            drawGradientRect(0, 0, width, height, backgroundColor.getLeft(), backgroundColor.getRight());
+        }
+
+
+        drawRectWidthHeight(popupX - 1, popupY - 1, popupWidth + 2, popupHeight + 2, 0xFFA0A0A0);
+
+        GL11.glEnable(GL11.GL_TEXTURE_2D);
+        float f = 32F;
+        tessellator.startDrawingQuads();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
+        tessellator.setColorOpaque_I(0x404040);
+        tessellator.addVertexWithUV(popupX, popupY + popupHeight, 0.0D, 0.0D, (float)popupHeight / f);
+        tessellator.addVertexWithUV(popupX + popupWidth, popupY + popupHeight, 0.0D, (float)popupWidth / f, (float)popupHeight / f);
+        tessellator.addVertexWithUV(popupX + popupWidth, popupY, 0.0D, (float)popupWidth / f, 0);
+        tessellator.addVertexWithUV(popupX, popupY, 0.0D, 0.0D, 0);
+        tessellator.draw();
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java b/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
index ddf2423bc..389e75fd4 100644
--- a/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/TextInputComponent.java
@@ -1,21 +1,21 @@
 package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiTextField;
+import net.minecraft.client.gui.TextFieldElement;
 
 public class TextInputComponent
     extends InteractivePopupComponent<String>
 {
-    private final GuiTextField textField;
+    private final TextFieldElement textField;
 
     public TextInputComponent(int width, String defaultText, String placeholder)
     {
         super(width);
-        this.textField = new GuiTextField(null, Minecraft.getMinecraft(this).fontRenderer, 0, 0, width, getHeight(), defaultText, placeholder);
+        this.textField = new TextFieldElement(null, Minecraft.getMinecraft(this).font, 0, 0, width, getHeight(), defaultText, placeholder);
     }
 
     @Override
-    public void setParent(GuiPopup parent)
+    public void setParent(PopupScreen parent)
     {
         super.setParent(parent);
         this.textField.parent = parent;
diff --git a/src/main/java/net/minecraft/client/gui/subtitles/SubtitleTracker.java b/src/main/java/net/minecraft/client/gui/subtitles/SubtitleTracker.java
new file mode 100644
index 000000000..0d7a8e120
--- /dev/null
+++ b/src/main/java/net/minecraft/client/gui/subtitles/SubtitleTracker.java
@@ -0,0 +1,68 @@
+package net.minecraft.client.gui.subtitles;
+
+import net.minecraft.client.sound.SoundEvent;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.util.helper.MathHelper;
+
+import java.util.ArrayList;
+import java.util.LinkedHashMap;
+import java.util.List;
+import java.util.Map;
+
+public class SubtitleTracker {
+    public static final int SUBTITLE_LIFETIME_MS = 5000;
+    public final Map<SoundEvent, SubtitleEntry> entryMap = new LinkedHashMap<>();
+
+    public void heardSound(SoundEvent event, double x, double y, double z) {
+        if (entryMap.containsKey(event)) {
+            entryMap.get(event).wasHeard(event, x, y, z);
+        } else {
+            entryMap.put(event, new SubtitleEntry(event, x, y, z));
+        }
+    }
+
+    private static final List<SoundEvent> removalQueue = new ArrayList<>();
+    public void tick() {
+        long currentTime = System.currentTimeMillis();
+        for (SubtitleEntry e : entryMap.values()) {
+            if (currentTime - e.lastHeardTime > SUBTITLE_LIFETIME_MS) {
+                removalQueue.add(e.soundEvent);
+            }
+        }
+        removalQueue.forEach(entryMap::remove);
+        removalQueue.clear();
+    }
+
+    public void clear() {
+        entryMap.clear();
+    }
+
+    public static class SubtitleEntry {
+        public double sourceX;
+        public double sourceY;
+        public double sourceZ;
+        public SoundEvent soundEvent;
+        public long lastHeardTime;
+        public SubtitleEntry(SoundEvent event, double x, double y, double z) {
+            wasHeard(event, x, y, z);
+        }
+
+        public void wasHeard(SoundEvent event, double x, double y, double z) {
+            this.sourceX = x;
+            this.sourceY = y;
+            this.sourceZ = z;
+            this.soundEvent = event;
+            this.lastHeardTime = System.currentTimeMillis();
+        }
+
+        public float getFadeout() {
+            return  ((float) (System.currentTimeMillis() - lastHeardTime) / SUBTITLE_LIFETIME_MS);
+        }
+
+        public double getRelativeAngle(Entity listener) {
+            if (listener == null) return Float.NaN;
+            double angle = Math.atan2(sourceZ - listener.z, sourceX - listener.x);
+            return angle - Math.toRadians(listener.yRot);
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java b/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
index fe10f3c52..67ebfd662 100644
--- a/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
+++ b/src/main/java/net/minecraft/client/gui/text/TextFieldEditor.java
@@ -1,8 +1,10 @@
 package net.minecraft.client.gui.text;
 
+import com.mojang.logging.LogUtils;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.core.util.helper.MathHelper;
+import org.slf4j.Logger;
 
 import java.awt.*;
 import java.awt.datatransfer.Clipboard;
@@ -12,6 +14,7 @@ import java.awt.datatransfer.Transferable;
 
 public class TextFieldEditor
 {
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static String substring(String s, int start, int end)
     {
         if (start < 0) start = 0;
@@ -178,7 +181,7 @@ public class TextFieldEditor
         if (cursor > currentText.length()) setCursor(currentText.length());
         if (cursor < 0) setCursor(0);
 
-        if (currentText.length() == 0)
+        if (currentText.isEmpty())
         {
             setText(String.valueOf(c));
         }
@@ -261,7 +264,7 @@ public class TextFieldEditor
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Exception while trying to copy text field to clipboard!", e);
         }
     }
 
@@ -277,7 +280,7 @@ public class TextFieldEditor
         }
         catch (Exception e)
         {
-            e.printStackTrace();
+            LOGGER.error("Exception while trying to read clipboard!", e);
         }
         return null;
     }
diff --git a/src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java b/src/main/java/net/minecraft/client/gui/toasts/HudToastsElement.java
similarity index 89%
rename from src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java
rename to src/main/java/net/minecraft/client/gui/toasts/HudToastsElement.java
index 497e3c57f..4109c35e2 100644
--- a/src/main/java/net/minecraft/client/gui/toasts/GuiHudToasts.java
+++ b/src/main/java/net/minecraft/client/gui/toasts/HudToastsElement.java
@@ -17,7 +17,7 @@ import java.util.ArrayList;
 import java.util.Comparator;
 import java.util.List;
 
-public class GuiHudToasts extends Gui {
+public class HudToastsElement extends Gui {
     private static final int TOAST_WIDTH = 160;
     private static final int TOAST_HEIGHT = 32;
     private static final int MAX_SHOWN_ENTRIES = 5;
@@ -27,7 +27,7 @@ public class GuiHudToasts extends Gui {
 
     private final Minecraft mc;
 
-    public GuiHudToasts(Minecraft minecraft) {
+    public HudToastsElement(Minecraft minecraft) {
         mc = minecraft;
     }
 
@@ -90,9 +90,9 @@ public class GuiHudToasts extends Gui {
             String s = I18n.getInstance().translateKeyAndFormat("gui.achievement.label.unlicensed.1", Global.VERSION);
             String s1 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.2");
             String s2 = I18n.getInstance().translateKey("gui.achievement.label.unlicensed.3");
-            mc.fontRenderer.drawStringWithShadow(s, 2, 2, 0xffffff);
-            mc.fontRenderer.drawStringWithShadow(s1, 2, 11, 0xffffff);
-            mc.fontRenderer.drawStringWithShadow(s2, 2, 20, 0xffffff);
+            mc.font.drawStringWithShadow(s, 2, 2, 0xffffff);
+            mc.font.drawStringWithShadow(s1, 2, 11, 0xffffff);
+            mc.font.drawStringWithShadow(s2, 2, 20, 0xffffff);
             GL11.glDepthMask(true);
             GL11.glEnable(GL11.GL_DEPTH_TEST);
         }
@@ -166,10 +166,10 @@ public class GuiHudToasts extends Gui {
 
         drawGuiIcon(x, y, TOAST_WIDTH, TOAST_HEIGHT, TextureRegistry.getTexture(toast.getTexture(duration)));
         if(toast.messageOnly(duration)) {
-            mc.fontRenderer.drawStringIntoConstrainedBlock(toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
+            mc.font.drawStringIntoConstrainedBlock(toast.getMessage(duration), x + 30, y + 7, 120, toast.descriptionColor(duration));
         } else {
-            mc.fontRenderer.drawString(toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
-            mc.fontRenderer.drawString(toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
+            mc.font.drawString(toast.getTitle(duration), x + 30, y + 7, toast.nameColor(duration));
+            mc.font.drawString(toast.getMessage(duration), x + 30, y + 18, toast.descriptionColor(duration));
         }
 
         GL11.glDepthMask(true);
@@ -179,7 +179,7 @@ public class GuiHudToasts extends Gui {
 
         GL11.glEnable(GL11.GL_DEPTH_TEST);
         ItemStack icon = toast.getIcon(duration);
-        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.fontRenderer, mc.renderEngine, icon, x + 8, y + 8, 1.0f);
+        ItemModelDispatcher.getInstance().getDispatch(icon).renderItemIntoGui(Tessellator.instance, mc.font, mc.textureManager, icon, x + 8, y + 8, 1.0f);
         GL11.glDisable(GL11.GL_DEPTH_TEST);
     }
 
diff --git a/src/main/java/net/minecraft/client/input/InputHandler.java b/src/main/java/net/minecraft/client/input/InputHandler.java
index b8f1c3ad2..4dca2a85a 100644
--- a/src/main/java/net/minecraft/client/input/InputHandler.java
+++ b/src/main/java/net/minecraft/client/input/InputHandler.java
@@ -1,14 +1,16 @@
 package net.minecraft.client.input;
 
-import net.minecraft.client.input.glfw.FakeGamepad;
+import com.mojang.logging.LogUtils;
+import net.minecraft.client.input.glfw.GlfwGamepad;
+import net.minecraft.client.input.glfw.GlfwJoystick;
 import org.lwjgl.glfw.GLFW;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
-import net.minecraft.client.input.glfw.GlfwGamepad;
-import net.minecraft.client.input.glfw.GlfwJoystick;
+import org.slf4j.Logger;
 
 public abstract class InputHandler {
+	private static final Logger LOGGER = LogUtils.getLogger();
 	private static Minecraft minecraft;
 	public static ControllerInput[] controllers = new ControllerInput[GLFW.GLFW_JOYSTICK_LAST + 1];
 	
@@ -18,7 +20,7 @@ public abstract class InputHandler {
 		try {
 			initLWJGL3(minecraft);
 		} catch (Throwable e) {
-			System.err.println("Could not initialize LWJGL3.");
+			LOGGER.error("Could not initialize LWJGL3.");
 			e.printStackTrace();
 		}
 	}
@@ -46,12 +48,12 @@ public abstract class InputHandler {
 	}
 
 	private static void connected(ControllerInput controller) {
-		System.out.println("Controller connected: " + controller.getGUID());
+        LOGGER.info("Controller connected: {}", controller.getGUID());
 		minecraft.controllerInput = getController(controller.getGUID());
 	}
 
 	private static void disconnected(ControllerInput controller) {
-		System.out.println("Controller disconnected: " + controller.getGUID());
+        LOGGER.info("Controller disconnected: {}", controller.getGUID());
 		if(minecraft.controllerInput == controller) {
 			minecraft.setInputType(InputType.KEYBOARD);
 			minecraft.controllerInput = null;
@@ -76,9 +78,9 @@ public abstract class InputHandler {
 //		for (int i = 0; i < vids.length; i++) {
 //			controllers[GLFW.GLFW_JOYSTICK_1 + i] = new ControllerInput(minecraft, new FakeGamepad(GLFW.GLFW_JOYSTICK_1 + i, names[i], vids[i], pids[i]));
 //		}
-		System.out.println(found + " controllers found!");
+    LOGGER.info("{} controllers found!", found);
 	}
-	
+
 	public static ControllerInput getController(String guid) {
 		try {
 			for(ControllerInput controllerInput : controllers) {
@@ -86,8 +88,7 @@ public abstract class InputHandler {
 					return controllerInput;
 				}
 			}
-		}catch (Exception e) {}
+		}catch (Exception ignored) {}
 		return null;
 	}
-
 }
